;  !debug !linkall console clean verbose resource !list
; 
;    .nolist

    .386                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive

    include \masm32\include\windows_po.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\shlwapi.inc
    include \masm32\include\user32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\shlwapi.lib
    includelib \masm32\lib\user32.lib

;    include \masm32\include\debug.inc
;    includelib \masm32\lib\debug.lib

;    .list
; 

    StdOutRes       PROTO :DWORD

; 

    .const
      ; CONSOLE DISPLAY STRINGS
      ;  are now in rsrc.rc
        szPressAnyKey       EQU 01h
        szAssemblingWith    EQU 10h
        SZAWDEBUG           EQU 11h
        SZAWCONSOLE         EQU 12h
        SZAWRESOURCE        EQU 13h
        SZAWDLL             EQU 14h
        SZAWCLEAN           EQU 15h
        SZAWLIST            EQU 16h
        SZAWLINKNONE        EQU 17h
        SZAWLINKALL         EQU 18h
        SZAWNOMAKEIT        EQU 19h
        SZAWMAKEITBAT       EQU 1Ah
        
        szExecute           EQU 20h
        
        szBuildFailed       EQU 30h
        szBuildSuccess      EQU 31h
        
        szLogo              EQU 100h
        szUsage             EQU 110h
        
      ; FILE RELATED STRING
        szML        BYTE    "poasm.exe ", 0
        szLINK      BYTE    "polink.exe ", 0
        szRC        BYTE    "porc.exe ", 0
        
        dwASMExt    LABEL DWORD   
                    BYTE  ".asm"
        dwRCExt     LABEL DWORD
                    BYTE  ".rc "
        dwDEFExt    LABEL DWORD
                    BYTE  ".def"
        dwLSTExt    LABEL DWORD
                    BYTE  ".lst"
        dwJAVExt    LABEL DWORD
                    BYTE  ".jav"
        dwDLLExt    LABEL DWORD
                    BYTE  ".dll"
        dwEXEExt    LABEL DWORD
                    BYTE  ".exe"
        
        dwEXPExt    LABEL DWORD
                    BYTE   ".exp"  ; Cleanable extensions
        dwOBJExt    LABEL DWORD
                    BYTE   ".obj"
        dwRESExt    LABEL DWORD
                    BYTE   ".res"
        dwPDBExt    LABEL DWORD
                    BYTE   ".pdb"
        
        dwZero      DWORD   0               ; This zero indicates the end of the cleanable extensions
        szSpace     BYTE    " ",0
        sz2CRLF     BYTE    13, 10          ; This string runs into the next one
        szCRLF      BYTE    13, 10, 0

        szDebuOpt   BYTE    " DEBUG", 0     ; Debug build
        szConsOpt   BYTE    " CONSOLE", 0   ; Console application
        szResoOpt   BYTE    " RESOURCE", 0  ; Includes resource file
        szDLLOpt    BYTE    " DLL", 0       ; Create a DLL
        szCleaOpt   BYTE    " CLEAN", 0     ; Delete temporary files afterwards
        szListOpt   BYTE    " LIST", 0      ; Create a file listing
        szVerbOpt   BYTE    " VERBOSE", 0   ; Verbose assembly mode
        szLNonOpt   BYTE    " NOLINK", 0    ; Do not link this file
        szLAllOpt   BYTE    " LINKALL", 0   ; Link ALL OBJ files in the directory
        szNoMaOpt   BYTE    " NOMAKEIT", 0  ; Suppress makeit.bat file

    .data
        szMLOpt     BYTE    "/AIA32"
        bMLDebug    BYTE    0   ; set to '/' if debug build
                    BYTE    "Zi ", 0
        
        szMLListOpt BYTE    0 ;"/nologo /c /Fl /Sc /Sn ", 0
        
        szRSRCRc    BYTE    "rsrc.rc ", 0
        szRSRCRes   BYTE    "rsrc.res ", 0
        szMakeItBat BYTE    "makeit.bat", 0
        
        szLinkWin   BYTE    "/SUBSYSTEM:WINDOWS "
        bLinkDebug1 BYTE    0           ; set to '/' if debug build
                    BYTE    "DEBUG ", 0
        szLinkCon   BYTE    "/SUBSYSTEM:CONSOLE "
        bLinkDebug2 BYTE    0           ; set to '/' if debug build
                    BYTE    "DEBUG ", 0
        
        szLinkAll   BYTE    " *.obj", 0
        szLinkDLL   BYTE    "/DLL ", 0
        szLinkDEF   BYTE    "/DEF:", 0
        lpLinkOpt   DWORD   OFFSET szLinkWin

    .data?
        szCommand   BYTE    512 DUP (?)
        szFilename  BYTE    256 DUP (?)
        szBinDir    BYTE    256 DUP (?)
        szHeader    BYTE    256 DUP (?)
        dwBytesRead DWORD   ?
        lpFileEXT   DWORD   ?
        
        dwOrigExtension DWORD   ?
        
        dwOptions   DWORD   ?
        
        VERBOSE     EQU     0001h
        DEBUG       EQU     0002h
        CONSOLE     EQU     0004h
        RESOURCE    EQU     0008h
        DLL         EQU     0010h
        CLEAN       EQU     0020h
        LIST        EQU     0040h
        LINKNONE    EQU     0080h
        LINKALL     EQU     0100h
        NOMAKEIT    EQU     0200h
    .code

; 

VerboseExecute	PROTO
wait_key    	PROTO
run_synch_process PROTO :DWORD

Start PROC USES esi edi
    LOCAL   hFile   :DWORD
    
    invoke  StdOutRes, szLogo
    invoke  StdOutRes, szLogo+1
    invoke  StdOutRes, szLogo+2


; ====================================
;       This section finds the bin path from the command line and
;       the project path from the process's current directory


    invoke  GetModuleFileName, NULL, OFFSET szBinDir, LENGTHOF szBinDir
    invoke  PathRemoveFileSpec, OFFSET szBinDir
    invoke  PathAddBackslash, OFFSET szBinDir
    
    invoke  GetCommandLine
    invoke  PathGetArgs, eax
    push    eax
    invoke  szCopy, eax, OFFSET szCommand
    
    invoke  PathUnquoteSpaces, OFFSET szCommand
    invoke  PathRemoveFileSpec, OFFSET szCommand
    test    BYTE PTR szCommand[0], -1
   jz      @F
    invoke  SetCurrentDirectory, OFFSET szCommand
   @@:
    
    pop     esi
    invoke  PathStripPath, esi
    sub     esi, 1
    mov     edi, OFFSET szFilename
    
   @@:
    add     esi, 1
    mov     al, [esi]
    or      al, al
    jz      @F
    cmp     al, '.'
    je      @F
    mov     [edi], al
    add     edi, 1
    jmp     @B
   @@:
    mov     lpFileEXT, edi
    and     DWORD PTR [edi+4], 0
    
    mov     eax, [esi]      ; puts DWORD extension in eax
    mov     dwOrigExtension, eax
    
    mov     esi, OFFSET dwEXPExt-4
   @@:
    add     esi, 4
    mov     eax, [esi]
    or      eax, eax
   jz      FinishedCleaning
    mov     [edi], eax
    invoke  DeleteFile, OFFSET szFilename
   jmp     @B
   FinishedCleaning:
    invoke  DeleteFile, OFFSET szRSRCRes
    
    mov     eax, dwOrigExtension
    mov     [edi], eax
    
    
    invoke  CreateFile, OFFSET szFilename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
    or      eax, eax
    jz      DisplayUsage
    mov     hFile, eax
    
    invoke  ReadFile, hFile, OFFSET szHeader, 256, OFFSET dwBytesRead, NULL
    invoke  CloseHandle, hFile
    test    dwBytesRead, 0FFFFFFFFh
    jz      DisplayUsage
    
    mov     esi, OFFSET szHeader
   AdjustLoopStart:
    add     esi, 1
    mov     al, [esi]
    or      al, al
    jz      DisplayUsage
    cmp     al, ' '
   je      AdjustLoopStart
    cmp     al, 13
   jne     @F
    xor     al, al
   @@:
    cmp     al, 10
   jne     @F
    xor     al, al
   @@:
    and     al, 11011111b       ; make uppercase
    mov     BYTE PTR [esi], al
    jnz     AdjustLoopStart
    
    and     BYTE PTR [esi], 0
;
; ====================================

; ====================================
;
;       Identify all options

; #######################################################################
SetOptions MACRO optstring, optvalue
   LOCAL templabel
    invoke  InString, 2, OFFSET szHeader, OFFSET optstring
    cmp     eax, 0
   jle     templabel
    or      dwOptions, optvalue
   templabel:
ENDM

PrintOption MACRO optstring, optvalue
    LOCAL templabel
    test    dwOptions, optvalue
   jz      templabel
    invoke  StdOutRes, SZAW#optstring
   templabel:
ENDM
; #######################################################################
    
    
    and     dwOptions, 0
    
    SetOptions  szVerbOpt, VERBOSE
    SetOptions  szDebuOpt, DEBUG
    SetOptions  szConsOpt, CONSOLE
    SetOptions  szResoOpt, RESOURCE
    SetOptions  szDLLOpt,  DLL
    SetOptions  szCleaOpt, CLEAN
    SetOptions  szListOpt, LIST
    SetOptions  szLNonOpt, LINKNONE
    SetOptions  szLAllOpt, LINKALL
    SetOptions  szNoMaOpt, NOMAKEIT

    .if(!(dwOptions & NOMAKEIT))
        invoke  PathFileExists, OFFSET szMakeItBat
        or      eax, eax
       jnz     UseMakeItBat
    .endif
    
    
    mov     eax, dwOrigExtension
    cmp     eax, dwASMExt
   je      ASMFile
    cmp     eax, dwRCExt
   je      ResourceFileOnly
    jmp     DisplayUsage
    
    
ASMFile:
    .if(dwOptions & VERBOSE)
        invoke  StdOutRes, szAssemblingWith
        PrintOption <DEBUG>, DEBUG
        PrintOption <CONSOLE>, CONSOLE
        PrintOption <RESOURCE>, RESOURCE
        PrintOption <DLL>, DLL
        PrintOption <CLEAN>, CLEAN
        PrintOption <LIST>, LIST
        PrintOption <LINKNONE>, LINKNONE
        PrintOption <LINKALL>, LINKALL
        PrintOption <NOMAKEIT>, NOMAKEIT
    .endif
    
    test    dwOptions, LIST
   jnz     CreateListing
    
    .if(dwOptions & DEBUG)
        mov     bMLDebug, '/'
        mov     bLinkDebug1, '/'
        mov     bLinkDebug2, '/'
    .endif
    
    .if(dwOptions & CONSOLE)
        mov     lpLinkOpt, OFFSET szLinkCon
    .endif
    
    invoke  szCopy, OFFSET szBinDir, OFFSET szCommand
    invoke  szMultiCat, 3, OFFSET szCommand, OFFSET szML, OFFSET szMLOpt, OFFSET szFilename
    
    call    VerboseExecute
    
    invoke  run_synch_process, OFFSET szCommand
    or      eax, eax
   jnz     BuildFailed
    
    
    test    dwOptions, LINKNONE
    jnz     BuildSuccess
    
    
    mov     esi, lpFileEXT
    mov     eax, dwOBJExt
    mov     [esi], eax
    
    test    dwOptions, RESOURCE
   jz      NoResourceFile

ResourceFile:
    
    invoke  szCopy, OFFSET szBinDir, OFFSET szCommand
    invoke  szMultiCat, 2, OFFSET szCommand, OFFSET szRC, OFFSET szRSRCRc
    call    VerboseExecute
    invoke  run_synch_process, OFFSET szCommand
    
    ;invoke  szCopy, OFFSET szBinDir, OFFSET szCommand
    ;invoke  szMultiCat, 2, OFFSET szCommand, OFFSET szCVTRES, OFFSET szCVTRESOpt
    ;call    VerboseExecute
    ;invoke  run_synch_process, OFFSET szCommand
    
    invoke  szCopy, OFFSET szBinDir, OFFSET szCommand
    invoke  szMultiCat, 2, OFFSET szCommand, OFFSET szLINK, lpLinkOpt
    
    .if(dwOptions & DLL)
        invoke  szMultiCat, 1, OFFSET szCommand, OFFSET szLinkDLL
    .endif
    
    or  eax, -1
    neg eax
    .if(dwOptions & LINKALL)
        push    OFFSET szLinkAll
    .else
        push    OFFSET szRSRCRes
        push    OFFSET szSpace
        push    OFFSET szFilename
        add     eax, 2
    .endif
    invoke  szMultiCat, eax, OFFSET szCommand ; last parameter/s have already been pushed
    
    .if(dwOptions & DLL)
        mov     eax, dwDEFExt
        mov     [esi], eax
        invoke  szMultiCat, 3, OFFSET szCommand, OFFSET szSpace, OFFSET szLinkDEF, OFFSET szFilename
        mov     eax, dwOBJExt
        mov     [esi], eax
    .endif
    
    call    VerboseExecute
    
    invoke  run_synch_process, OFFSET szCommand
    or      eax, eax
   jnz     BuildFailed
    
    
    .if(dwOptions & CLEAN)
        invoke  DeleteFile, OFFSET szRSRCRes
        ;invoke  DeleteFile, OFFSET szRSRCObj
        invoke  DeleteFile, OFFSET szFilename
    .endif
    
    jmp     BuildSuccess


NoResourceFile:

    invoke  szCopy, OFFSET szBinDir, OFFSET szCommand

    mov     edx, OFFSET szFilename
    .if(dwOptions & LINKALL)
        mov     edx, OFFSET szLinkAll
    .endif
    
    invoke  szMultiCat, 3, OFFSET szCommand, OFFSET szLINK, lpLinkOpt, edx

    .if(dwOptions & DLL)
        mov     eax, dwDEFExt
        mov     [esi], eax
        invoke  szMultiCat, 4, OFFSET szCommand, OFFSET szSpace, OFFSET szLinkDLL, OFFSET szLinkDEF, OFFSET szFilename
        mov     eax, dwOBJExt
        mov     [esi], eax
    .endif
    call    VerboseExecute

    invoke  run_synch_process, OFFSET szCommand
    or      eax, eax
   jnz     BuildFailed
    
    .if(dwOptions & CLEAN)
        invoke  DeleteFile, OFFSET szFilename
    .endif
    
    jmp BuildSuccess
    
CreateListing:
    invoke  szCopy, OFFSET szBinDir, OFFSET szCommand
    invoke  szMultiCat, 3, OFFSET szCommand, OFFSET szML, OFFSET szMLListOpt, OFFSET szFilename
    call    VerboseExecute
    
    invoke  run_synch_process, OFFSET szCommand
    or      eax, eax
   jnz     BuildFailed
    
    mov     esi, lpFileEXT
    mov     eax, dwLSTExt
    mov     [esi], eax
    
    invoke  ShellExecute, 0, NULL, OFFSET szFilename, NULL, NULL, SW_SHOWDEFAULT
    jmp     QuietSuccess
    
ResourceFileOnly:
    invoke  szCopy, OFFSET szBinDir, OFFSET szCommand
    invoke  szMultiCat, 2, OFFSET szCommand, OFFSET szRC, OFFSET szRSRCRc
    call    VerboseExecute
    invoke  run_synch_process, OFFSET szCommand
    or      eax, eax
   jnz     BuildFailed
    jmp     BuildSuccess
    
UseMakeItBat:
    pop     esi
    invoke  StdOutRes, SZAWMAKEITBAT
    invoke  StdOut, OFFSET sz2CRLF
    invoke  szCopy, OFFSET szMakeItBat, OFFSET szCommand
    call VerboseExecute
    invoke  run_synch_process, OFFSET szMakeItBat
    jmp     QuietSuccess
    
BuildFailed:
    invoke  StdOutRes, szBuildFailed
    invoke  StdOutRes, szPressAnyKey
    call    wait_key
    invoke  ExitProcess, 1
    ret
    
DisplayUsage:
    mov     esi, szUsage
   @@:
    invoke  StdOutRes, esi
    inc     esi
    or      eax, eax
   jnz     @B
    invoke  ExitProcess, 2
    ret
    
BuildSuccess:
    invoke  StdOutRes, szBuildSuccess
    invoke  StdOutRes, szPressAnyKey
    call    wait_key
    
QuietSuccess:
    invoke  ExitProcess, 0
    ret
Start ENDP


; 

.data?
    szStdOutResBuffer   BYTE    1024 DUP (?)
.code

StdOutRes PROC dwRes:DWORD
    invoke  GetModuleHandle, NULL
    invoke  LoadString, eax, dwRes, OFFSET szStdOutResBuffer, 1024
    or      eax, eax
   jz      @F
    push    eax
    invoke  StdOut, OFFSET szStdOutResBuffer
    pop     eax
   @@:
    ret
StdOutRes ENDP

; 

VerboseExecute PROC
    test    dwOptions, VERBOSE
   jz     @F
    invoke  StdOut, OFFSET szCRLF
    invoke  StdOutRes, szExecute
    invoke  StdOut, OFFSET szCommand
    invoke  StdOut, OFFSET sz2CRLF
   @@:
    ret
VerboseExecute ENDP

; 

wait_key PROC
    LOCAL   hConsole:DWORD
    LOCAL   dwConsoleMode:DWORD
    
    invoke  GetStdHandle, STD_INPUT_HANDLE
    mov     hConsole, eax
    
    invoke  GetConsoleMode, hConsole, ADDR dwConsoleMode
    invoke  SetConsoleMode, hConsole, 0
    invoke  ReadFile, hConsole, NULL, 1, NULL, NULL
    invoke  SetConsoleMode, hConsole, dwConsoleMode

    invoke  FlushConsoleInputBuffer, hConsole
    ret
wait_key ENDP




run_synch_process PROC lpCommand:DWORD

    LOCAL st_info:STARTUPINFO
    LOCAL pr_info:PROCESS_INFORMATION

  ; ---------------------
  ; zero fill STARTUPINFO
  ; ---------------------
    mov ecx, 17                 ; 68 bytes SIZEOF STARTUPINFO
    lea edx, st_info
    xor eax, eax
  @@:
    mov [edx], eax
    add edx, 4
    sub ecx, 1
    jnz @B
    mov st_info.dwFlags, STARTF_USESHOWWINDOW

    mov st_info.cb, 68          ; set the structure size member

    invoke CreateProcess,NULL,lpCommand,NULL,NULL,
                         NULL,NULL,NULL,NULL,
                         ADDR st_info,
                         ADDR pr_info

    test eax, eax               ; if CreateProcess fails
    jnz @F
    ;mov eax, -2                 ; set return value for CreateProcess fail
    ret

  @@:
    invoke SetPriorityClass,pr_info.hProcess,0

    invoke WaitForSingleObjectEx,pr_info.hProcess,INFINITE,0
    push   eax
    invoke GetExitCodeProcess, pr_info.hProcess, esp    ; pushes mem space for return value

    invoke CloseHandle, pr_info.hThread
    invoke CloseHandle, pr_info.hProcess

    pop eax                     ; return value from GetExitCodeProcess

    ret

comment * ---------------------------------
    WaitForSingleObjectEx return values

    WAIT_FAILED               equ -1
    WAIT_OBJECT_0             equ 0
    WAIT_ABANDONED            equ 00000080h
    WAIT_ABANDONED_0          equ 00000080h
    WAIT_TIMEOUT              equ 00000102h
    WAIT_IO_COMPLETION        equ 000000C0h
        --------------------------------- *

run_synch_process ENDP
END Start
